--- a/ext/curl/interface.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/curl/interface.c	2025-10-25 03:24:13.151647843 +0000
@@ -453,7 +453,7 @@
 	clone_ch->cp = cp;
 	_php_setup_easy_copy_handlers(clone_ch, ch);
 
-	postfields = &clone_ch->postfields;
+	postfields = &ch->postfields;
 	if (Z_TYPE_P(postfields) != IS_UNDEF) {
 		if (build_mime_structure_from_hash(clone_ch, postfields) == FAILURE) {
 			zend_throw_exception(NULL, "Failed to clone CurlHandle", 0);
@@ -643,10 +643,10 @@
 /* }}} */
 
 /* {{{ curl_progress */
-static size_t curl_progress(void *clientp, double dltotal, double dlnow, double ultotal, double ulnow)
+static int curl_progress(void *clientp, double dltotal, double dlnow, double ultotal, double ulnow)
 {
 	php_curl *ch = (php_curl *)clientp;
-	size_t	rval = 0;
+	int rval = 0;
 
 #if PHP_CURL_DEBUG
 	fprintf(stderr, "curl_progress() called\n");
@@ -681,10 +681,10 @@
 /* }}} */
 
 /* {{{ curl_xferinfo */
-static size_t curl_xferinfo(void *clientp, curl_off_t dltotal, curl_off_t dlnow, curl_off_t ultotal, curl_off_t ulnow)
+static int curl_xferinfo(void *clientp, curl_off_t dltotal, curl_off_t dlnow, curl_off_t ultotal, curl_off_t ulnow)
 {
 	php_curl *ch = (php_curl *)clientp;
-	size_t rval = 0;
+	int rval = 0;
 
 #if PHP_CURL_DEBUG
 	fprintf(stderr, "curl_xferinfo() called\n");
@@ -1190,8 +1190,8 @@
 {
 	char *cainfo;
 
-	curl_easy_setopt(ch->cp, CURLOPT_NOPROGRESS,        1);
-	curl_easy_setopt(ch->cp, CURLOPT_VERBOSE,           0);
+	curl_easy_setopt(ch->cp, CURLOPT_NOPROGRESS,        1L);
+	curl_easy_setopt(ch->cp, CURLOPT_VERBOSE,           0L);
 	curl_easy_setopt(ch->cp, CURLOPT_ERRORBUFFER,       ch->err.str);
 	curl_easy_setopt(ch->cp, CURLOPT_WRITEFUNCTION,     curl_write);
 	curl_easy_setopt(ch->cp, CURLOPT_FILE,              (void *) ch);
@@ -1199,8 +1199,8 @@
 	curl_easy_setopt(ch->cp, CURLOPT_INFILE,            (void *) ch);
 	curl_easy_setopt(ch->cp, CURLOPT_HEADERFUNCTION,    curl_write_header);
 	curl_easy_setopt(ch->cp, CURLOPT_WRITEHEADER,       (void *) ch);
-	curl_easy_setopt(ch->cp, CURLOPT_DNS_CACHE_TIMEOUT, 120);
-	curl_easy_setopt(ch->cp, CURLOPT_MAXREDIRS, 20); /* prevent infinite redirects */
+	curl_easy_setopt(ch->cp, CURLOPT_DNS_CACHE_TIMEOUT, 120L);
+	curl_easy_setopt(ch->cp, CURLOPT_MAXREDIRS, 20L); /* prevent infinite redirects */
 
 	cainfo = INI_STR("openssl.cafile");
 	if (!(cainfo && cainfo[0] != '\0')) {
@@ -1211,7 +1211,7 @@
 	}
 
 #ifdef ZTS
-	curl_easy_setopt(ch->cp, CURLOPT_NOSIGNAL, 1);
+	curl_easy_setopt(ch->cp, CURLOPT_NOSIGNAL, 1L);
 #endif
 }
 /* }}} */
@@ -1701,7 +1701,7 @@
 			lval = zval_get_long(zvalue);
 			if (lval == 1) {
 				php_error_docref(NULL, E_NOTICE, "CURLOPT_SSL_VERIFYHOST no longer accepts the value 1, value 2 will be used instead");
-				error = curl_easy_setopt(ch->cp, option, 2);
+				error = curl_easy_setopt(ch->cp, option, 2L);
 				break;
 			}
 			ZEND_FALLTHROUGH;
@@ -2207,7 +2207,7 @@
 
 		case CURLOPT_FOLLOWLOCATION:
 			lval = zend_is_true(zvalue);
-			error = curl_easy_setopt(ch->cp, option, lval);
+			error = curl_easy_setopt(ch->cp, option, (long) lval);
 			break;
 
 		case CURLOPT_POSTFIELDS:
@@ -2216,7 +2216,7 @@
 					/* no need to build the mime structure for empty hashtables;
 					   also works around https://github.com/curl/curl/issues/6455 */
 					curl_easy_setopt(ch->cp, CURLOPT_POSTFIELDS, "");
-					error = curl_easy_setopt(ch->cp, CURLOPT_POSTFIELDSIZE, 0);
+					error = curl_easy_setopt(ch->cp, CURLOPT_POSTFIELDSIZE, 0L);
 				} else {
 					return build_mime_structure_from_hash(ch, zvalue);
 				}
@@ -2249,7 +2249,7 @@
 
 		case CURLOPT_POSTREDIR:
 			lval = zval_get_long(zvalue);
-			error = curl_easy_setopt(ch->cp, CURLOPT_POSTREDIR, lval & CURL_REDIR_POST_ALL);
+			error = curl_easy_setopt(ch->cp, CURLOPT_POSTREDIR, (long) (lval & CURL_REDIR_POST_ALL));
 			break;
 
 		/* the following options deal with files, therefore the open_basedir check
@@ -2289,11 +2289,11 @@
 			if (zend_is_true(zvalue)) {
 				curl_easy_setopt(ch->cp, CURLOPT_DEBUGFUNCTION, curl_debug);
 				curl_easy_setopt(ch->cp, CURLOPT_DEBUGDATA, (void *)ch);
-				curl_easy_setopt(ch->cp, CURLOPT_VERBOSE, 1);
+				curl_easy_setopt(ch->cp, CURLOPT_VERBOSE, 1L);
 			} else {
 				curl_easy_setopt(ch->cp, CURLOPT_DEBUGFUNCTION, NULL);
 				curl_easy_setopt(ch->cp, CURLOPT_DEBUGDATA, NULL);
-				curl_easy_setopt(ch->cp, CURLOPT_VERBOSE, 0);
+				curl_easy_setopt(ch->cp, CURLOPT_VERBOSE, 0L);
 			}
 			break;
 
diff '--color=auto' -Naur a/ext/curl/tests/curl_copy_handle_variation3_clone.phpt b/ext/curl/tests/curl_copy_handle_variation3_clone.phpt
--- a/ext/curl/tests/curl_copy_handle_variation3_clone.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/curl/tests/curl_copy_handle_variation3_clone.phpt	2025-10-25 03:24:13.152227880 +0000
@@ -0,0 +1,34 @@
+--TEST--
+clone() allows to post CURLFile multiple times
+--EXTENSIONS--
+curl
+--FILE--
+<?php
+include 'server.inc';
+$host = curl_cli_server_start();
+
+$ch1 = curl_init();
+curl_setopt($ch1, CURLOPT_SAFE_UPLOAD, 1);
+curl_setopt($ch1, CURLOPT_URL, "{$host}/get.php?test=file");
+curl_setopt($ch1, CURLOPT_RETURNTRANSFER, 1);
+
+$filename = __DIR__ . '/curl_copy_handle_variation3_clone.txt';
+file_put_contents($filename, "Test.");
+$file = curl_file_create($filename);
+$params = array('file' => $file);
+var_dump(curl_setopt($ch1, CURLOPT_POSTFIELDS, $params));
+
+$ch2 = clone($ch1);
+
+var_dump(curl_exec($ch1));
+
+var_dump(curl_exec($ch2));
+?>
+--EXPECTF--
+bool(true)
+string(%d) "curl_copy_handle_variation3_clone.txt|application/octet-stream|5"
+string(%d) "curl_copy_handle_variation3_clone.txt|application/octet-stream|5"
+--CLEAN--
+<?php
+@unlink(__DIR__ . '/curl_copy_handle_variation3_clone.txt');
+?>
diff '--color=auto' -Naur a/ext/curl/tests/curl_setopt_ssl.phpt b/ext/curl/tests/curl_setopt_ssl.phpt
--- a/ext/curl/tests/curl_setopt_ssl.phpt	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/curl/tests/curl_setopt_ssl.phpt	2025-10-25 03:24:13.152338151 +0000
@@ -18,9 +18,13 @@
 --FILE--
 <?php
 
-function check_error(CurlHandle $ch) {
+function check_error(CurlHandle $ch, $expected = null) {
     if (curl_errno($ch) !== 0) {
-        echo "CURL ERROR: " . curl_errno($ch) . "\n";
+        $errno = curl_errno($ch);
+        if (!is_null($expected)) {
+            $errno = $errno == $expected ? 'EXPECTED' : "UNEXPECTED(A:$errno,E:$expected)";
+        }
+        echo "CURL ERROR: " . $errno . "\n";
     }
 }
 
@@ -109,7 +113,7 @@
 
     $response = curl_exec($ch);
     check_response($response, $clientCertSubject);
-    check_error($ch);
+    check_error($ch, curl_version()['version_number'] < 0x081000 ? 58 : 43);
     curl_close($ch);
 
     echo "\n";
@@ -203,7 +207,7 @@
 bool(true)
 bool(true)
 client cert subject not in response
-CURL ERROR: 58
+CURL ERROR: EXPECTED
 
 case 4: client cert and key from file
 bool(true)
diff '--color=auto' -Naur a/ext/date/lib/parse_date.c b/ext/date/lib/parse_date.c
--- a/ext/date/lib/parse_date.re	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/date/lib/parse_date.re	2025-10-25 03:24:13.156800552 +0000
@@ -939,10 +939,12 @@
 {
 	timelib_tzinfo *res;
 	timelib_long            retval = 0;
+	size_t paren_count = 0;
 
 	*tz_not_found = 0;
 
 	while (**ptr == ' ' || **ptr == '\t' || **ptr == '(') {
+		paren_count += **ptr == '(';
 		++*ptr;
 	}
 	if ((*ptr)[0] == 'G' && (*ptr)[1] == 'M' && (*ptr)[2] == 'T' && ((*ptr)[3] == '+' || (*ptr)[3] == '-')) {
@@ -991,8 +993,9 @@
 		*tz_not_found = (found == 0);
 		retval = offset;
 	}
-	while (**ptr == ')') {
+	while (paren_count > 0 && **ptr == ')') {
 		++*ptr;
+		paren_count--;
 	}
 	return retval;
 }
diff '--color=auto' -Naur a/ext/date/lib/parse_iso_intervals.c b/ext/date/lib/parse_iso_intervals.c
--- a/ext/date/lib/timelib.h	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/date/lib/timelib.h	2025-10-25 03:24:13.157263812 +0000
@@ -1,7 +1,7 @@
 /*
  * The MIT License (MIT)
  *
- * Copyright (c) 2015-2024 Derick Rethans
+ * Copyright (c) 2015-2025 Derick Rethans
  * Copyright (c) 2018,2021 MongoDB, Inc.
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
@@ -30,9 +30,9 @@
 # include "timelib_config.h"
 #endif
 
-#define TIMELIB_VERSION 202212
-#define TIMELIB_EXTENDED_VERSION 20221201
-#define TIMELIB_ASCII_VERSION "2022.12"
+#define TIMELIB_VERSION 202214
+#define TIMELIB_EXTENDED_VERSION 20221401
+#define TIMELIB_ASCII_VERSION "2022.14"
 
 #include <stdlib.h>
 #include <stdbool.h>
diff '--color=auto' -Naur a/ext/dba/dba.c b/ext/dba/dba.c
--- a/ext/dba/dba.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/dba/dba.c	2025-10-25 03:24:13.157442806 +0000
@@ -1070,6 +1070,11 @@
 		ZEND_PARSE_PARAMETERS_END();
 	}
 
+	if (ZEND_LONG_EXCEEDS_INT(skip)) {
+		zend_argument_value_error(3, "must be between %d and %d", INT_MIN, INT_MAX);
+		RETURN_THROWS();
+	}
+
 	info = Z_DBA_INFO_P(id);
 	CHECK_DBA_CONNECTION(info);
 
diff '--color=auto' -Naur a/ext/dba/tests/gh19885.phpt b/ext/dba/tests/gh19885.phpt
--- a/ext/dba/tests/gh19885.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/dba/tests/gh19885.phpt	2025-10-25 03:24:13.157568578 +0000
@@ -0,0 +1,35 @@
+--TEST--
+GH-19885 (dba_fetch() segfault on large skip values)
+--EXTENSIONS--
+dba
+--SKIPIF--
+<?php
+if (PHP_INT_SIZE != 8) die("skip this test is for 64bit platform only");
+$handler = 'cdb';
+require_once(__DIR__ .'/skipif.inc');
+?>
+--FILE--
+<?php
+$handler = 'cdb';
+$db_file = __DIR__.'/test.cdb';
+$db =dba_open($db_file, "r", $handler);
+try {
+	dba_fetch("1", $db, PHP_INT_MIN);
+} catch (\ValueError $e) {
+	echo $e->getMessage(), PHP_EOL;
+}
+
+try {
+	dba_fetch("1", $db, PHP_INT_MAX);
+} catch (\ValueError $e) {
+	echo $e->getMessage(), PHP_EOL;
+}
+// negative skip needs to remain acceptable albeit corrected down the line
+var_dump(dba_fetch("1", $db, -1000000));
+?>
+--EXPECTF--
+dba_fetch(): Argument #3 ($skip) must be between -%d and %d
+dba_fetch(): Argument #3 ($skip) must be between -%d and %d
+
+Notice: dba_fetch(): Handler cdb accepts only skip values greater than or equal to zero, using skip=0 in %s on line %d
+string(1) "1"
diff '--color=auto' -Naur a/ext/dom/attr.c b/ext/dom/attr.c
--- a/ext/dom/attr.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/dom/attr.c	2025-10-25 03:24:13.157643397 +0000
@@ -201,10 +201,10 @@
 
 bool dom_compare_value(const xmlAttr *attr, const xmlChar *value)
 {
-	bool free;
-	xmlChar *attr_value = php_libxml_attr_value(attr, &free);
+	bool should_free;
+	xmlChar *attr_value = php_libxml_attr_value(attr, &should_free);
 	bool result = xmlStrEqual(attr_value, value);
-	if (free) {
+	if (should_free) {
 		xmlFree(attr_value);
 	}
 	return result;
diff '--color=auto' -Naur a/ext/dom/lexbor/lexbor/selectors-adapted/selectors.c b/ext/dom/lexbor/lexbor/selectors-adapted/selectors.c
--- a/ext/dom/lexbor/lexbor/selectors-adapted/selectors.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/dom/lexbor/lexbor/selectors-adapted/selectors.c	2025-10-25 03:24:13.157781744 +0000
@@ -13,7 +13,7 @@
 #include <Zend/zend_API.h>
 #include <php.h>
 
-#include "ext/dom/lexbor/lexbor/selectors-adapted/selectors.h"
+#include "lexbor/selectors-adapted/selectors.h"
 #include "../../../namespace_compat.h"
 #include "../../../domexception.h"
 #include "../../../php_dom.h"
diff '--color=auto' -Naur a/ext/dom/php_dom.c b/ext/dom/php_dom.c
--- a/ext/dom/php_dom.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/dom/php_dom.c	2025-10-25 03:24:13.158042007 +0000
@@ -2396,10 +2396,10 @@
 		}
 
 		case XML_ATTRIBUTE_NODE: {
-			bool free;
-			xmlChar *value = php_libxml_attr_value((const xmlAttr *) nodep, &free);
+			bool should_free;
+			xmlChar *value = php_libxml_attr_value((const xmlAttr *) nodep, &should_free);
 			RETVAL_STRING_FAST((const char *) value);
-			if (free) {
+			if (should_free) {
 				xmlFree(value);
 			}
 			return;
diff '--color=auto' -Naur a/ext/gd/libgd/gdkanji.c b/ext/gd/libgd/gdkanji.c
--- a/ext/gd/libgd/gdkanji.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/gd/libgd/gdkanji.c	2025-10-25 03:24:13.158289777 +0000
@@ -368,6 +368,8 @@
       else
 	error ("something happen");
       strcpy ((char *) to, (const char *) from);
+      if (iconv_close (cd) != 0)
+      	error ("iconv_close() error");
       return;
     }
 
diff '--color=auto' -Naur a/ext/gd/tests/gh19955.phpt b/ext/gd/tests/gh19955.phpt
--- a/ext/gd/tests/gh19955.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/gd/tests/gh19955.phpt	2025-10-25 03:24:13.158374784 +0000
@@ -0,0 +1,15 @@
+--TEST--
+GH-19955: (imagefttext() memory leak)
+--EXTENSIONS--
+gd
+--CREDITS--
+YuanchengJiang
+--FILE--
+<?php
+ini_set('error_reporting', E_ALL&~E_WARNING);
+$im = imagecreate(64, 32);
+imagefttext(imagecreate(8, 8), 0, 0, 0, 0, 255, __DIR__ . "/Tuffy.ttf", 'Ж');
+echo "OK"
+?>
+--EXPECT--
+OK
diff '--color=auto' -Naur a/ext/mysqli/tests/bug67563.phpt b/ext/mysqli/tests/bug67563.phpt
--- a/ext/mysqli/tests/bug67563.phpt	1970-01-01 00:00:00.000000000 +0000
+++ b/ext/mysqli/tests/bug67563.phpt	2025-10-25 03:24:13.158465740 +0000
@@ -0,0 +1,40 @@
+--TEST--
+Fix bug #67563 (mysqli compiled with mysqlnd does not take ipv6 adress as parameter)
+--EXTENSIONS--
+mysqli
+--SKIPIF--
+<?php
+require_once 'connect.inc';
+
+if ($host !== '127.0.0.1')
+    die('skip local test');
+
+if (@stream_socket_client('udp://[::1]:8888') === false)
+    die('skip no IPv6 support 2');
+
+if (!$link = @my_mysqli_connect($host, $user, $passwd, $db, $port, $socket)) {
+    die(sprintf("SKIP Cannot connect to the server using host=%s, user=%s, passwd=***, dbname=%s, port=%s, socket=%s\n",
+        $host, $user, $db, $port, $socket));
+}
+?>
+--INI--
+max_execution_time=240
+--FILE--
+<?php
+require_once 'connect.inc';
+
+$hosts = ['::1', "[::1]:$port"];
+
+foreach ($hosts as $host) {
+    if (!$link = my_mysqli_connect($host, $user, $passwd, $db, $port, $socket)) {
+        printf("[001] Cannot connect to the server using host=%s, user=%s, passwd=%s dbname=%s, port=%s, socket=%s\n",
+            $host, $user, $passwd, $db, $port, $socket);
+    } else {
+        $link->close();
+    }
+}
+
+print "done!";
+?>
+--EXPECT--
+done!
diff '--color=auto' -Naur a/ext/mysqli/tests/fetch/mysqli_fetch_all_data_types_variation.phpt b/ext/mysqli/tests/fetch/mysqli_fetch_all_data_types_variation.phpt
--- a/ext/mysqli/tests/fetch/mysqli_fetch_all_data_types_variation.phpt	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/mysqli/tests/fetch/mysqli_fetch_all_data_types_variation.phpt	2025-10-25 03:24:13.158547280 +0000
@@ -4,6 +4,9 @@
 mysqli
 --SKIPIF--
 <?php
+if (getenv('GITHUB_ACTIONS') && str_starts_with(php_uname('m'), 'ppc')) {
+    die('skip Flaky on GitHub Actions PPC runner');
+}
 require_once dirname(__DIR__) . "/test_setup/test_helpers.inc";
 mysqli_check_skip_test();
 ?>
diff '--color=auto' -Naur a/ext/mysqlnd/mysqlnd_connection.c b/ext/mysqlnd/mysqlnd_connection.c
--- a/ext/mysqlnd/mysqlnd_connection.c	2025-09-23 14:14:32.000000000 +0000
+++ b/ext/mysqlnd/mysqlnd_connection.c	2025-10-25 03:24:13.158699556 +0000
@@ -513,6 +513,16 @@
 }
 /* }}} */
 
+/* ipv6 addresses have at least two colons, which is how we can differentiate between domain names and addresses */
+static bool mysqlnd_fast_is_ipv6_address(const char *s)
+{
+	const char *first_colon = strchr(s, ':');
+	if (!first_colon) {
+		return false;
+	}
+	return strchr(first_colon + 1, ':') != NULL;
+}
+
 /* {{{ mysqlnd_conn_data::get_scheme */
 static MYSQLND_STRING
 MYSQLND_METHOD(mysqlnd_conn_data, get_scheme)(MYSQLND_CONN_DATA * conn, MYSQLND_CSTRING hostname, MYSQLND_CSTRING *socket_or_pipe, unsigned int port, bool * unix_socket, bool * named_pipe)
@@ -542,7 +552,13 @@
 		if (!port) {
 			port = 3306;
 		}
-		transport.l = mnd_sprintf(&transport.s, 0, "tcp://%s:%u", hostname.s, port);
+
+		/* ipv6 addresses are in the format [address]:port */
+		if (hostname.s[0] != '[' && mysqlnd_fast_is_ipv6_address(hostname.s)) {
+			transport.l = mnd_sprintf(&transport.s, 0, "tcp://[%s]:%u", hostname.s, port);
+		} else {
+			transport.l = mnd_sprintf(&transport.s, 0, "tcp://%s:%u", hostname.s, port);
+		}
 	}
 	DBG_INF_FMT("transport=%s", transport.s? transport.s:"OOM");
 	DBG_RETURN(transport);
diff '--color=auto' -Naur a/ext/opcache/jit/ir/ir_aarch64.dasc b/ext/opcache/jit/ir/ir_aarch64.dasc
